# /packages/intranet-filestorage/www/create-folder-2.tcl
#
# Copyright (C) 2003 - 2009 ]project-open[
#
# All rights reserved. Please check
# https://www.project-open.com/license/ for details.


ad_page_contract {
    Create a new directory

    @author pvilarmau@hotmail.com
    @author santitrenchs@santitrenchs.com
    @author frank.bergmann@project-open.com
} {
    folder_type
    folder_name
    bread_crum_path
    object_id:notnull
    return_url:notnull
}

set user_id [auth::require_login]
set base_path [im_filestorage_base_path $folder_type $object_id]


# Get the list of all relevant roles and profiles for permissions
set roles [im_filestorage_roles $user_id $object_id]
set profiles [im_filestorage_profiles $user_id $object_id]

# Get the group membership of the current (viewing) user
set user_memberships [im_filestorage_user_memberships $user_id $object_id]

# Get the list of all (known) permission of all folders of the FS
# of the current object
set perm_hash_array [im_filestorage_get_perm_hash $user_id $object_id $user_memberships]
array set perm_hash $perm_hash_array


# Check permissions and skip
set user_perms [im_filestorage_folder_permissions $user_id $object_id $bread_crum_path $user_memberships $roles $profiles $perm_hash_array]
set admin_p [lindex $user_perms 3]
if {!$admin_p} {
    ad_return_complaint 1 "You don't have permission to create a subdirectory in folder '$bread_crum_path'"
    return
}

if {"" != $bread_crum_path} { append base_path "/" }
append base_path $bread_crum_path

set char_style [parameter::get -package_id [im_package_filestorage_id] -parameter "FilenameCharactersSupported" -default "none"]
set folder_name [im_l10n_normalize_string -style $char_style $folder_name]

file mkdir "$base_path/$folder_name"

ad_returnredirect $return_url
















