# ]po[ File Storage
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About ]po[ File Storage:

<p><p>This package includes the main file storage functionality in ]project-open[. Files can be attached to <a href="/en/object-type-user">users</a>, <a href="/en/object-type-im-project">projects</a>, <a href="/en/object-type-im-ticket">tickets</a> and <a href="/en/object-type-im-company">companies</a>. The file storage is normally used to store project information, but can also store contract information for users, quotes and presentations of customer etc. <p>This file storage implementation has been designed to: <ul><li>Store files on a plain file system.<li>Allows for integration with a (Windows) departmental file server.<li>It does not support versioning of files. </ul><p>Users can access the files in two ways (if the file server integration is used): <ul><li>via the ]project-open[ Web interface (please see the screenshots below) and<li>via the Windows file explorer directly from a Windows client. <li>You can also use a program like <a href="https://winscp.net/eng/index.php">WinSCP<span class="external"> </span></a> to access your files when using a Linux backend. </ul><p>We plan for a new <a href="/en/package-intranet-filestorage-ajax">AJAX file storage</a> for ]project-open[ V4.1 that will support versioning and feature an updated user interface. <p><p><img src="https://www.project-open.com/images/manual_screenshots/screenshot_filestorage.gif" /><p>(Screenshot of in-]project-open[ display of filestorage contents. Can be found at the bottom of the &quot;Home&quot; page on the standard default distribution of ]project-open[.) <p><p><img src="https://www.project-open.com/images/manual_screenshots/screenshot_filestorage_1.gif" /><p>(To navigate to sub-folders and view their contents, simply click on the appropriate icon. To return click on the hyper-link corresponding to the preceding folder you wish to visit as is highlighted above.) <p>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=550&amp;path=packages/intranet-filestorage/tcl/intranet-filestorage-procs.tcl">tcl/intranet-filestorage-procs.tcl</a></b></td><td></td><td>File Storage Component Library This file storage type sets the access rights to project folders according to some regular expressions, that determine the read/write permissions for the project profiles: - Admin r/w all - Sales r all, w sales - Member r/w all except sales - Trans r source trans edit proof, w trans - Editor r source trans edit proof, w edit - Proof r source trans edit proof, w proof </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=export_url_bind_vars">export_url_bind_vars</a></b></td><td></td><td>Returns the variable tail of the URL based on the variables found in the bind_vars parameter. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_file_action_download">im_file_action_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_file_action_upload">im_file_action_upload</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_backup_path">im_filestorage_backup_path</a></b></td><td></td><td>Helper to determine the location where global backup files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_base_component">im_filestorage_base_component</a></b></td><td></td><td>Main funcion to generate the filestorage page ( create folder, bread crum, ....) </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_bread_crum">im_filestorage_bread_crum</a></b></td><td></td><td>Returns a formatted HTML component indicating the relative position in the current folder </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_bug_component">im_filestorage_bug_component</a></b></td><td></td><td>Filestorage for Bug-Tracker </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_bug_path">im_filestorage_bug_path</a></b></td><td></td><td>Determine the location where the bug files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_check_filename">im_filestorage_check_filename</a></b></td><td></td><td>Check what types of characters are supported - supported by the underlying filesystem. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_company_component">im_filestorage_company_component</a></b></td><td></td><td>Filestorage for companies </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_company_path">im_filestorage_company_path</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_company_path_helper">im_filestorage_company_path_helper</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_conf_item_component">im_filestorage_conf_item_component</a></b></td><td></td><td>Filestorage for conf_item items </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_conf_item_path">im_filestorage_conf_item_path</a></b></td><td></td><td>Determine the location where the conf_item files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_copy_source_directory">im_filestorage_copy_source_directory</a></b></td><td></td><td>Create directory structure for a new project Returns &quot;&quot; if successful Returns a formatted errors string otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_cost_component">im_filestorage_cost_component</a></b></td><td></td><td>Filestorage for cost items </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_cost_path">im_filestorage_cost_path</a></b></td><td></td><td>Determine the location where the cost files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_create_directories">im_filestorage_create_directories</a></b></td><td></td><td>Copy the files from project/source_xx folder to subpoject/source_yy Returns a formatted errors string otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_delete_folder">im_filestorage_delete_folder</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_dir_row">im_filestorage_dir_row</a></b></td><td></td><td>Create a directory row with links for open/close and bread_crum enter </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_event_component">im_filestorage_event_component</a></b></td><td></td><td>Filestorage for events </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_event_path">im_filestorage_event_path</a></b></td><td></td><td>Determine the location where the event files are stored on the hard disk for this event </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_event_path_helper">im_filestorage_event_path_helper</a></b></td><td></td><td>Determine the location where the event files are stored on the hard disk for this event </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_file_row">im_filestorage_file_row</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_file_type_icon">im_filestorage_file_type_icon</a></b></td><td></td><td>Returns a suitable icon for the specified file extension </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_find_cmd">im_filestorage_find_cmd</a></b></td><td></td><td>Returns the Unix/Linux/Windows find command as specified in the intranet-core.FindCmd command </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_find_cmd_helper">im_filestorage_find_cmd_helper</a></b></td><td></td><td>Returns the Unix/Linux/Windows find command as specified in the intranet-core.FindCmd command </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_find_files">im_filestorage_find_files</a></b></td><td></td><td>Returns a list of files in a project directory </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_folder_permissions">im_filestorage_folder_permissions</a></b></td><td></td><td>Get the userss permissions for a specific path. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_get_perm_hash">im_filestorage_get_perm_hash</a></b></td><td></td><td>Returns a hash (path -&gt; [v r w a]) for all pathes of the current object. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_home_component">im_filestorage_home_component</a></b></td><td></td><td>Filestorage for global corporate files </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_home_folder_profile_perms">im_filestorage_home_folder_profile_perms</a></b></td><td></td><td>Returns a TCL list [list $view $read $write $admin] of the profile&#39;s permission on the home folder. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_home_path">im_filestorage_home_path</a></b></td><td></td><td>Helper to determine the location where global company files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_is_directory_empty">im_filestorage_is_directory_empty</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_path_perms">im_filestorage_path_perms</a></b></td><td></td><td>Returns a hash of (profile_ids -&gt; [1 1 1 1]) for the given path, inheriting permissions from all super-directories </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_perm_add_profile">im_filestorage_perm_add_profile</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_perm_add_role">im_filestorage_perm_add_role</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_profile_tds">im_filestorage_profile_tds</a></b></td><td></td><td>Returns a rendered HTML component showing the icons of all profiles and object roles for a specific business objects. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_profiles">im_filestorage_profiles</a></b></td><td></td><td>Returns a list of profile_id-profile_gif-profile_name tuples for a given filestorage. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_component">im_filestorage_project_component</a></b></td><td></td><td>Filestorage for projects </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_path">im_filestorage_project_path</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk for this project </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_path_helper">im_filestorage_project_path_helper</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk for this project </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_sales_component">im_filestorage_project_sales_component</a></b></td><td></td><td>Filestorage for project sales (protected) </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_sales_path">im_filestorage_project_sales_path</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk for this project </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_sales_path_helper">im_filestorage_project_sales_path_helper</a></b></td><td></td><td>Determine the location where the project files are stored on the hard disk for this project </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_project_workflow_dirs">im_filestorage_project_workflow_dirs</a></b></td><td></td><td>Returns a list of directors that have to be created as a function of the project type (workfow) # 85: Trans Only # 86: Trans + Edit # 87: Edit Only # 88: Trans + Edit + Proof # 89: Linguistic Validation # 90: Localization # 91: Other # 92: Technology # 93: Unknown # 94: Trans + Internal Edit </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_risk_component">im_filestorage_risk_component</a></b></td><td></td><td>Filestorage for risk items </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_risk_path">im_filestorage_risk_path</a></b></td><td></td><td>Determine the location where the risk files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_roles">im_filestorage_roles</a></b></td><td></td><td>Returns a list of role_id-role_gif-role_name tuples for a given filestorage. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_template_path">im_filestorage_template_path</a></b></td><td></td><td>Helper to determine the location where global template files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_ticket_component">im_filestorage_ticket_component</a></b></td><td></td><td>Filestorage for tickets </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_ticket_path">im_filestorage_ticket_path</a></b></td><td></td><td>Determine the location where the ticket files are stored on the hard disk for this ticket </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_ticket_path_helper">im_filestorage_ticket_path_helper</a></b></td><td></td><td>Determine the location where the ticket files are stored on the hard disk for this ticket </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_tmp_path">im_filestorage_tmp_path</a></b></td><td></td><td>Determine the location temporary files are stored </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_tool_tds">im_filestorage_tool_tds</a></b></td><td></td><td>Returns a formatted HTML component with a number of GIFs. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_user_component">im_filestorage_user_component</a></b></td><td></td><td>Filestorage for users </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_user_path">im_filestorage_user_path</a></b></td><td></td><td>Determine the location where the user files are stored on the hard disk </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_filestorage_zip_path">im_filestorage_zip_path</a></b></td><td></td><td>Determine the location where zips are located </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=im_package_filestorage_id">im_package_filestorage_id</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_company_download">intranet_company_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_conf_item_download">intranet_conf_item_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_cost_download">intranet_cost_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_event_download">intranet_event_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_expense_cost_download">intranet_expense_cost_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_home_download">intranet_home_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_project_download">intranet_project_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_project_sales_download">intranet_project_sales_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_risk_download">intranet_risk_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_ticket_download">intranet_ticket_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_user_download">intranet_user_download</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=550&amp;proc=intranet_zip_download">intranet_zip_download</a></b></td><td></td><td></td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-filestorage&amp;url=common/intranet-filestorage-common.sql&amp;version_id=550">sql/common/intranet-filestorage-common.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-filestorage&amp;url=postgresql/intranet-filestorage-create.sql&amp;version_id=550">sql/postgresql/intranet-filestorage-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=intranet-filestorage&amp;url=postgresql/intranet-filestorage-drop.sql&amp;version_id=550">sql/postgresql/intranet-filestorage-drop.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/action.adp">action.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/action.tcl">action.tcl</a></b></td><td>Single point of entry for all FS related actions.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/add-perms-2.tcl">add-perms-2.tcl</a></b></td><td>Show the content a specific subdirectory</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/create-folder-2.tcl">create-folder-2.tcl</a></b></td><td>Create a new directory</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/del-perms-2.tcl">del-perms-2.tcl</a></b></td><td>Show the content a specific subdirectory</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/delete.tcl">delete.tcl</a></b></td><td>Show the content a specific subdirectory</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/download.tcl">download.tcl</a></b></td><td>Download a file</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/folder_status_update.tcl">folder_status_update.tcl</a></b></td><td>Index page of filestorage</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/index.tcl">index.tcl</a></b></td><td>Shows a certain filestorage: By default shows the &quot;Home&quot;-Filestorage.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/upload-2.tcl">upload-2.tcl</a></b></td><td>insert a file into the file system</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=550&amp;path=packages/intranet-filestorage/www/upload-zip-2.tcl">upload-zip-2.tcl</a></b></td><td>insert a file into the file system</td></tr></table>

